//---------------------------------------------------------------------------

#ifndef TFrmMax4400xTestH
#define TFrmMax4400xTestH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <System.Actions.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <VCLTee.Chart.hpp>
#include <VCLTee.TeEngine.hpp>
#include <VCLTee.Series.hpp>
#include "VCLTee.TeeTools.hpp"
#include <VCLTee.TeeProcs.hpp>

//---------------------------------------------------------------------------
class TFrmMax4400xTest : public TForm
{
__published:	// IDE-managed Components
	TButton *Button1;
	TButton *Button2;
	TActionList *acts_;
	TAction *actConfigure_;
	TAction *actStartStop_;
	TGroupBox *GroupBox1;
	TLabel *Label1;
	TLabel *clear_;
	TLabel *Label3;
	TLabel *r_;
	TLabel *Label5;
	TLabel *g_;
	TLabel *Label7;
	TLabel *b_;
	TLabel *Label9;
	TLabel *ir_;
	TLabel *Label11;
	TLabel *irc_;
	TLabel *Label13;
	TLabel *temp_;
	TGridPanel *GridPanel1;
	TGroupBox *GroupBox2;
	TCheckBox *ambint_;
	TCheckBox *shdn_;
	TCheckBox *pwron_;
	TCheckBox *reset_;
	TGroupBox *GroupBox3;
	TEdit *cm00_;
	TEdit *cm10_;
	TEdit *cm20_;
	TEdit *cm01_;
	TEdit *cm11_;
	TEdit *cm21_;
	TEdit *cm02_;
	TEdit *cm12_;
	TEdit *cm22_;
	TButton *Button3;
	TAction *actApplyCm_;
	TGroupBox *GroupBox4;
	TGridPanel *GridPanel2;
	TLabel *Label2;
	TLabel *X_;
	TLabel *Label6;
	TLabel *Y_;
	TLabel *Label10;
	TLabel *Z_;
	TLabel *Label4;
	TLabel *xx_;
	TLabel *Label12;
	TLabel *yy_;
	TChart *chart_;
	TPaintBox *color_;
	TGroupBox *GroupBox5;
	TGroupBox *GroupBox6;
	TCheckBox *CheckBox1;
	TAction *actCompIR_;
	TLabel *Label8;
	TLabel *lblAtt_;
	TCheckBox *ESTAT_;
	TCheckBox *EAMBCFG_;
	TCheckBox *EDATAC_;
	TCheckBox *EDATAG_;
	TCheckBox *ECFG_;
	TCheckBox *ETHRESH_;
	TCheckBox *EDATAR_;
	TCheckBox *EDATAB_;
	TCheckBox *EIR_;
	TCheckBox *EIRC_;
	TCheckBox *ETEMP_;
	TButton *Button4;
	TAction *actResetCm_;
	TCheckBox *CheckBox2;
	TAction *actGDIp_;

	void __fastcall cportPacket_Packet(TObject *Sender, const UnicodeString Str);
	void __fastcall actConfigure_Execute(TObject *Sender);
	void __fastcall actConfigure_Update(TObject *Sender);
	void __fastcall actStartStop_Execute(TObject *Sender);
	void __fastcall actStartStop_Update(TObject *Sender);
	void __fastcall actApplyCm_Execute(TObject *Sender);
	void __fastcall actApplyCm_Update(TObject *Sender);
	void __fastcall color_Paint(TObject *Sender);
	void __fastcall cport_AfterOpen(TObject *Sender);
	void __fastcall cport_AfterClose(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall actCompIR_Execute(TObject *Sender);
	void __fastcall actCompIR_Update(TObject *Sender);
	void __fastcall actResetCm_Execute(TObject *Sender);
	void __fastcall chart_BeforeDrawSeries(TObject *Sender);
	void __fastcall actGDIp_Execute(TObject *Sender);
	void __fastcall actGDIp_Update(TObject *Sender);

public:		// User declarations
	__fastcall TFrmMax4400xTest(TComponent* Owner);

protected:
	static TColor rgbToRGB(const double* rgb);
	static void clrSpaceTransform(const double* mx, const double* sFrom, double* sTo, double att = 1);
	void chartInit();
	void colorSpaceFillInit();
	void colorSpaceChartInit();
	void cmDefaultInit();
	void cmToCmEdit();
	void cmEditToCm();
	void rgb2XYZ();
	void XYZ2xyz(double X, double Y, double Z, double& x, double& y, double& z);
	void XYZ2xyz();
	void irCompSet(bool irComp);
	void doIrComp();
	void colorDataUpdate();
	void attSet(int att);

	void __fastcall locus_GetMarkText(TChartSeries *Sender, int ValueIndex, UnicodeString &MarkText);
	void __fastcall locus_GetTipText(TMarksTipTool *Sender, UnicodeString &MarkText);

protected:
	bool m_invalidFill;
	bool m_irComp;
	double m_att;
	double m_rgbOrg[3];
	double m_rgb[3];
	double m_cict[4];
	double m_cm[9];
	double m_XYZ[3];
	double m_xyz[3];
	TRect m_polyRect;
	std::auto_ptr<TBitmap> m_bmp;
	std::vector<TPoint> m_poly;
	// tee renderer
	TTeeGDIPlus* m_gdip;
	// tee series & tools
	TLineSeries* m_assymtotic;
	TLineSeries* m_locus;
	TLineSeries* m_clrt;
	TNearestTool* m_wlTip;
	TPointSeries* m_pnt;
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmMax4400xTest *FrmMax4400xTest;
//---------------------------------------------------------------------------
#endif
